#ifndef __USERLIST_H__
#define __USERLIST_H__

#include <stdio.h>      /* printf(), sprintf(), perror() */
#include <io.h>         /* open(), read(), write(), unlink(), filelength() */
#include <string.h>     /* strlen() */
#include <stdlib.h>     /* malloc(), exit() */
#include <fcntl.h>      /* O_xxxx defines */
#include <sys/stat.h>	/* S_Ixxxx defines */
#include <ctype.h>      /* toupper() */
#include <conio.h>      /* cprintf(), textcolor() */

/*
**  demo code for converting Pascal string to C strings
**
**  public domain by Bob Stout
*/
#define P2Cconvert(s) {int n = *(s); memmove((s), &(s)[1], n); s[n] = '\0';}
#define C2Pconvert(s) {int n = strlen(s); memmove(&(s)[1], (s), n); *(s) = n;}


#define SIZE     118        /* Grootte van een LASTCALL.BBS record */
#define BUF_SIZE 80 * SIZE  /* Grootte van de inlees buffer */

#define TITLE	"UserList"
#define VERSION "1.02"

#define ASC     0
#define ANS     1
#define AVT 	2

#define REP_TITLE       " The last %d callers to %s:   [at %s]\r\n\r\n"
#define REP_USER_HEAD	" %-25s %-20s %-5s  %s  %s %s\r\n"
#define REP_USER        " %-25.25s %-20.20s %5s  %5s  %5s  %-5ld\r\n"
#define REP_USER_FOOT   " The total connection time is %s\r\n\r\n"
#define REP_BPS_HEAD    " Overview of BPS rates\r\n"
#define REP_BPS_FOOT    " %3d connection%smade today.\r\n"
#define REP_COPYRITE    "\r\n Report made by %s %s. Written by D. Heering\r\n"
#define REP_PRESS       " Press [ENTER] to continue..\x1"


/* Zet \ achteraan path indien nog */
void    checkpath( char *s );

/* Print welcome message */
void	welcome( void );

/* Print usage message */
void	usage( char *name );

/* Functie die file opent, of error geeft als dat niet lukt.. */
int 	fileopen( char *path, int access, unsigned mode );

/* Functie die naar file schrijft, en string cleared */
int     writefile( int fh, char *buf, int length );

/* Maakt timestamp string van LASTCALL.BBS */
void 	gettimestamp( int fh, char time_string[ 21 ] );

/* Schrijft BPS overzicht naar file */
void 	writespeeds( int *fh, int *speeds, int records );

/* Bereken hoelang BBS bezet was */
void 	calctime( char *s, word *online );

/* Functies die een header naar de output files schrijven */
void	write_header( const char *name, int *fh, char time[ 21 ], int recs, int type );

/* Functie die een user entry naar de ring buffer schrijft */
void 	update_ring( LASTCALL *user, LASTCALL *buf_ring, int *buf_first, int *buf_last, int ENTRIES );

/* Functie die de ring buffer naar de output file schrijft */
void 	write_ring( int *fh, LASTCALL *buf_ring, int *buf_first, int *buf_last, int ENTRIES );

/* Functie die footer naar output files schrijft */
void	write_footer( int *fh, int *speeds, int records, word *online, int type );

/* Houd het aantal bellers op snelheid xxxx bij */
void	update_speeds( word baud, int *speed );

/* Houd bij hoelang gebruikers BBS bezet hebben gehouden */
void	update_online( LASTCALL *user, word *online );

#endif
